QGIS Application - Bug report #7289
Add JOM CMake option to enable building with Qt JOM
2013-03-07 10:12 PM - Nathan Woodrow

Status: Closed

Priority: Normal

Assignee: Larry Shaffer

Category: Build/Install

Affected QGIS version:master Regression?: No
Operating System: Windows Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupls data: Copied to github as #: 16298
Description

Don't set

ADD_DEFINITIONS( /W4 )
ADD_DEFINITIONS(/FR)

if JOM is enabled as it causes issues building

History

#1 - 2013-03-08 07:06 PM - Larry Shaffer
- Status changed from Open to In Progress

Working setup: https://github.com/qgis/Quantum-GIS/pull/464

Tested on two different Win 7 VMs, with no errors.

The errors with ggis_help and gbrowser were fixed by updating Visual Studio Express to SP1:

Get MS VS2008 w/ SP1 iso here (~750 MB):
http://search.msdn.microsoft.com/search/en-US/default.aspx?query=visual%20studio%20express%202008%20download&#38;refinement=111&#38;ac
4

or directly (maybe):
http://download.microsoft.com/download/E/8/E/ESEEB394-7F42-4963-A2D8-29559B738298/VS2008ExpressWithSP1ENUX1504728.iso

Will add more about the QtCreator and .batch file configurations in followup post.

#2 - 2013-03-11 12:35 PM - Larry Shaffer
- File qgis-qtc-install-start.bat added

- File qgis-qtc-build-start.bat added

- File qgis-qtc-start.bat added

- File gtc-cmake-options.txt added

- File gbrowser-qtc-build-start.bat added

- File qgis-qtc-cmake-gui.bat added

- File qgis-build-shell.bat added

- File gbrowser-qtc-install-start.bat added
https://github.com/qgis/Quantum-GIS/pull/464
http://search.msdn.microsoft.com/search/en-US/default.aspx?query=visual%20studio%20express%202008%20download&#38;refinement=111&#38;ac=4
http://search.msdn.microsoft.com/search/en-US/default.aspx?query=visual%20studio%20express%202008%20download&#38;refinement=111&#38;ac=4
http://download.microsoft.com/download/E/8/E/E8EEB394-7F42-4963-A2D8-29559B738298/VS2008ExpressWithSP1ENUX1504728.iso

So here are my results/notes so far for setting up Qt Creator and NMake with jom:

- Windows 7 Home 64-bit

- 4 GBRAM

- 6 CPUs

- Two different Parallels 7 virtual machines (running under Mac OS X 10.7.5)
- Visual Studio Express with SP1 (as noted above)

- Windows 7 SDK for debugging in QtCreator

The following differs from current INSTALL notes:
- Microsoft Platform SDK for Windows Server 2003 R2 install doesn't appear to be necessary (at least | couldn't find any CMake options that utilized
anything from that install). SetupAPI appears to be useable from: C:/Program Files/Microsoft SDKs/Windows/v6.0A/Lib/SetupAPI.Lib, though | can't say |

know what it is used for exactly.

- linstalled the GNU tools, flex and bison, in C:/GnuWin32. Using Progra~1 or Progra~2 (for 64bit) still produced path-with-spaces problems for the

tools.

- The general shell environment batch file setup | used (though | don't use this shell env anymore once QtCreator was setup):

attachment:qgis-build-shell.bat
| used a separate virtual hard drive for source files and build directory at @:\\Quantum-GIS and Q:\\build-qtc. There seemed to be an issue with having
only the build directory being on a separate HDD, which was mitigated when | placed the source files there as well. The installed app goes into my home

folder: C:/Users/me/QGIS/QGIS_Apps-Qtc

The INSTALL notes should include the info about generally creating a CMake project, like opening the top-level CMakeLists.txt and inputting default

options.
Since Qt Creator works better when passing in CMake options via options dialog (rather than using CMake-GUI, etc), | keep a text file handy with the
default options | pass in, for initial project setup and for whenever Creator randomly asks for them. (These are just my choices for initial options):
attachment:qgtc-cmake-options.txt
The project build steps are as follows (-j option may be unnecessary unless you want jom to NOT automatically use all of your available CPU cores):
jom.exe -j6
jom.exe -j6 staged-plugins (optional, unless running from build dir)
jom.exe -j6 install (optional)

For launching Creator | use the following batch file: attachment:qgis-qgtc-start.bat

Once built and installed, | use the following to launch QGIS from build dir and install dir, respectively: attachment:qgis-qtc-build-start.bat and

attachment:qgis-qtc-install-start.bat

And similarly for the gbrowser application: attachment:gbrowser-gtc-build-start.bat and attachment:gbrowser-gtc-install-start.bat

For running CMake-GUI (if needed): attachment:qgis-gtc-cmake-gui.bat

It is best to run CMake-GUI while Creator is open, otherwise, you may be prompted with the default CMake options dialog on Qt Creator launch after using
CMake-GUI. Likewise, any changes done with CMake-GUI will be reverted if they are not reflected in future inputted options to Qt Creator's CMake options

dialog. Generally, | avoid using CMake-GUI to change CMakeCache.txt when using Qt Creator, and only use it to browse current settings.

For debugging, | installed Windows 7 SDK (just Developer Tools) and set the path to CDB debugger manually in Options->Build-n-Run->Kits->Desktop (it
http://download.microsoft.com/download/E/8/E/E8EEB394-7F42-4963-A2D8-29559B738298/VS2008ExpressWithSP1ENUX1504728.iso
http://download.microsoft.com/download/7/A/B/7ABD2203-C472-4036-8BA0-E505528CCCB7/winsdk_web.exe

was not auto-detected by Qt Creator): C:\\Program Files\\Debugging Tools for Windows (x64)\\cdb.exe

#3 - 2013-05-10 08:37 PM - Nathan Woodrow
- Resolution set to fixed
- Status changed from In Progress to Closed

Files

qgis-qtc-cmake-gui.bat 624 Bytes 2013-03-11 Larry Shaffer
gbrowser-qtc-build-start.bat 307 Bytes 2013-03-11 Larry Shaffer
gbrowser-gtc-install-start.bat 329 Bytes 2013-03-11 Larry Shaffer
qgis-build-shell.bat 764 Bytes 2013-03-11 Larry Shaffer
gtc-cmake-options.txt 263 Bytes 2013-03-11 Larry Shaffer
qgis-qtc-start.bat 626 Bytes 2013-03-11 Larry Shaffer
qgis-qtc-build-start.bat 295 Bytes 2013-03-11 Larry Shaffer
qgis-qtc-install-start.bat 317 Bytes 2013-03-11 Larry Shaffer
